ScriptName DialogueFollowerScript extends Quest Conditional

GlobalVariable Property pPlayerFollowerCount Auto
GlobalVariable Property pPlayerAnimalCount Auto
ReferenceAlias Property pFollowerAlias Auto
ReferenceAlias property pAnimalAlias Auto
Faction Property pDismissedFollower Auto
Faction Property pCurrentHireling Auto
Message Property  FollowerDismissMessage Auto
Message Property AnimalDismissMessage Auto
Message Property  FollowerDismissMessageWedding Auto
Message Property  FollowerDismissMessageCompanions Auto
Message Property  FollowerDismissMessageCompanionsMale Auto
Message Property  FollowerDismissMessageCompanionsFemale Auto
Message Property  FollowerDismissMessageWait Auto
SetHirelingRehire Property HirelingRehireScript Auto

;Property to tell follower to say dismissal line
Int Property iFollowerDismiss Auto Conditional

; PATCH 1.9: 77615: remove unplayable hunting bow when follower is dismissed
Weapon Property FollowerHuntingBow Auto
Ammo Property FollowerIronArrow Auto

; added by FM
int property Slot0 = 1 auto conditional
int maxFollowers = 100
Actor[] actorRefs

ReferenceAlias Property FollowerAlias2 Auto
ReferenceAlias Property FollowerAlias3 Auto
ReferenceAlias Property FollowerAlias4 Auto
ReferenceAlias Property FollowerAlias5 Auto

Function SetFollower(ObjectReference FollowerRef)

	actor FollowerActor = FollowerRef as Actor
	If ActorRefs.length != 100
		ActorRefs = new Actor[100]
	EndIf
	Int i = Self.FindFreeSlot()
	ActorRefs[i] = FollowerActor
	If i == 0
		pFollowerAlias.ForceRefTo(FollowerActor as ObjectReference)
		Slot0 = 0
	ElseIf i == 1
		FollowerAlias2.ForceRefTo(FollowerActor as ObjectReference)
	ElseIf i == 2
		FollowerAlias3.ForceRefTo(FollowerActor as ObjectReference)
	ElseIf i == 3
		FollowerAlias4.ForceRefTo(FollowerActor as ObjectReference)
	ElseIf i == 4
		FollowerAlias5.ForceRefTo(FollowerActor as ObjectReference)
	Else
		Return 
	EndIf
	FollowerActor.RemoveFromFaction(pDismissedFollower)
	If FollowerActor.GetRelationshipRank(Game.GetPlayer()) < 3 && FollowerActor.GetRelationshipRank(Game.GetPlayer()) >= 0
		FollowerActor.SetRelationshipRank(Game.GetPlayer(), 3)
	EndIf
	FollowerActor.SetPlayerTeammate()
	;FollowerActor.SetAV("Morality", 0)
	;pFollowerAlias.ForceRefTo(FollowerActor)
	pPlayerFollowerCount.SetValue(pPlayerFollowerCount.GetValue() + 1)
	
EndFunction

Function SetAnimal(ObjectReference AnimalRef)

	actor AnimalActor= AnimalRef as Actor
	;don't allow lockpicking
	AnimalActor.SetAV("Lockpicking", 0)
	AnimalActor.SetRelationshipRank(Game.GetPlayer(), 3)
	AnimalActor.SetPlayerTeammate(abCanDoFavor = false)
	pAnimalAlias.ForceRefTo(AnimalActor)
	;AnimalActor.AllowPCDialogue(True)
	pPlayerAnimalCount.SetValue(1)
	
EndFunction

Function FollowerWait(ObjectReference ref)

	;actor FollowerActor = pFollowerAlias.GetActorRef() as Actor
	Actor FollowerActor
	Int Slot = Self.FindMatchingSlot(ref as Actor)
	If Slot == 0
		FollowerActor = pFollowerAlias.GetActorRef()
		pFollowerAlias.RegisterForUpdateGameTime(720 as float)
	ElseIf Slot == 1
		FollowerActor = FollowerAlias2.GetActorRef()
		FollowerAlias2.RegisterForUpdateGameTime(720 as float)
	ElseIf Slot == 2
		FollowerActor = FollowerAlias3.GetActorRef()
		FollowerAlias3.RegisterForUpdateGameTime(720 as float)
	ElseIf Slot == 3
		FollowerActor = FollowerAlias4.GetActorRef()
		FollowerAlias4.RegisterForUpdateGameTime(720 as float)
	ElseIf Slot == 4
		FollowerActor = FollowerAlias5.GetActorRef()
		FollowerAlias5.RegisterForUpdateGameTime(720 as float)
	EndIf
	FollowerActor.SetAv("WaitingForPlayer", 1)
	;SetObjectiveDisplayed(10, abforce = true)
	;follower will wait 3 days
	;pFollowerAlias.RegisterForUpdateGameTime(72)

EndFunction

Function AnimalWait()

	actor AnimalActor = pAnimalAlias.GetActorRef() as Actor
	AnimalActor.SetAv("WaitingForPlayer", 1)
	;SetObjectiveDisplayed(20, abforce = true)
	;follower will wait 3 days
	pAnimalAlias.RegisterForUpdateGameTime(72)

EndFunction

Function FollowerFollow(ObjectReference ref)

	;actor FollowerActor = pFollowerAlias.GetActorRef() as Actor

	Actor FollowerActor
	Int Slot = Self.FindMatchingSlot(ref as Actor)
	If Slot == 0
		FollowerActor = pFollowerAlias.GetActorRef()
	ElseIf Slot == 1
		FollowerActor = FollowerAlias2.GetActorRef()
	ElseIf Slot == 2
		FollowerActor = FollowerAlias3.GetActorRef()
	ElseIf Slot == 3
		FollowerActor = FollowerAlias4.GetActorRef()
	ElseIf Slot == 4
		FollowerActor = FollowerAlias5.GetActorRef()
	EndIf
	FollowerActor.SetAv("WaitingForPlayer", 0)
	SetObjectiveDisplayed(10, abdisplayed = false)

EndFunction

Function AnimalFollow()

	actor AnimalActor = pAnimalAlias.GetActorRef() as Actor
	AnimalActor.SetAv("WaitingForPlayer", 0)
	SetObjectiveDisplayed(20, abdisplayed = false)

EndFunction

Function DismissFollower(Int iMessage = 0, Int iSayLine = 1, ObjectReference obj)

	Actor DismissedFollowerActor
	If iMessage == 2
		Return 
	EndIf
	Int Slot = 0
	If obj != none
		Actor CallAct = obj as Actor
		Slot = Self.FindMatchingSlot(CallAct)
		If Slot == 0
			DismissedFollowerActor = pFollowerAlias.GetActorRef()
			Slot0 = 1
			pFollowerAlias.Clear()
		ElseIf Slot == 1
			DismissedFollowerActor = FollowerAlias2.GetActorRef()
			FollowerAlias2.Clear()
		ElseIf Slot == 2
			DismissedFollowerActor = FollowerAlias3.GetActorRef()
			FollowerAlias3.Clear()
		ElseIf Slot == 3
			DismissedFollowerActor = FollowerAlias4.GetActorRef()
			FollowerAlias4.Clear()
		ElseIf Slot == 4
			DismissedFollowerActor = FollowerAlias5.GetActorRef()
			FollowerAlias5.Clear()
		Else
			Return 
		EndIf
		ActorRefs[Slot] = none
	Else
		DismissedFollowerActor = pFollowerAlias.GetActorRef()
		pFollowerAlias.Clear()
		ActorRefs[0] = none
	EndIf

	;If pFollowerAlias && pFollowerAlias.GetActorRef().IsDead() == False
	If DismissedFollowerActor.IsDead() == false
		If iMessage == 0
			FollowerDismissMessage.Show()
		ElseIf iMessage == 1
			FollowerDismissMessageWedding.Show()
		ElseIf iMessage == 2
			FollowerDismissMessageCompanions.Show()
		ElseIf iMessage == 3
			FollowerDismissMessageCompanionsMale.Show()
		ElseIf iMessage == 4
			FollowerDismissMessageCompanionsFemale.Show()
		ElseIf iMessage == 5
			FollowerDismissMessageWait.Show()
		Else
			;failsafe
			FollowerDismissMessage.Show()
		EndIf
		;actor DismissedFollowerActor = pFollowerAlias.GetActorRef() as Actor
		DismissedFollowerActor.StopCombatAlarm()
		DismissedFollowerActor.AddToFaction(pDismissedFollower)
		DismissedFollowerActor.SetPlayerTeammate(false)
		DismissedFollowerActor.RemoveFromFaction(pCurrentHireling)
		DismissedFollowerActor.SetAV("WaitingForPlayer", 0)	

		; PATCH 1.9: 77615: remove unplayable hunting bow when follower is dismissed
		DismissedFollowerActor.RemoveItem(FollowerHuntingBow, 999, true)
		DismissedFollowerActor.RemoveItem(FollowerIronArrow, 999, true)
		; END Patch 1.9 fix

		;hireling rehire function
		HirelingRehireScript.DismissHireling(DismissedFollowerActor.GetActorBase())
		If iSayLine == 1
			iFollowerDismiss = 1
			DismissedFollowerActor.EvaluatePackage()
			;Wait for follower to say line
			Utility.Wait(2)
		EndIf
		;pFollowerAlias.Clear()
		iFollowerDismiss = 0
		;don't set count to 0 if Companions have replaced follower
		If iMessage == 2
			;do nothing
		Else
			pPlayerFollowerCount.SetValue(pPlayerFollowerCount.GetValue() - 1)
		EndIf
	EndIf

EndFunction

Function DismissAnimal()

	If pAnimalAlias && pAnimalAlias.GetActorRef().IsDead() == False
		actor DismissedAnimalActor = pAnimalAlias.GetActorRef() as Actor
		DismissedAnimalActor.SetActorValue("Variable04", 0)
		;DismissedAnimalActor.AllowPCDialogue(False)
		pPlayerAnimalCount.SetValue(0)
		pAnimalAlias.Clear()
		AnimalDismissMessage.Show()
	EndIf

EndFunction

; added by FM

Int Function FindMatchingSlot(Actor ref)

	Int i
	If ref == none
		Return -1
	EndIf
	While i < MaxFollowers && actorRefs[i] != ref
		i += 1
	EndWhile
	If i >= MaxFollowers
		i = -1
	EndIf
	Return i
EndFunction

Int Function FindFreeSlot()

	Int i
	While i < MaxFollowers && actorRefs[i] != none
		i += 1
	EndWhile
	If i >= MaxFollowers
		i = -1
	EndIf
	Return i
EndFunction
